# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RendererExternalresourcesBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'item': 'FormserviceapiformsrendererexternalresourcesItem',
        'filter': 'str',
        'value_source': 'FormserviceapiformsrendererexternalvalidationSource',
        'value_type': 'FormserviceapiformsrendererexternalvaluesFieldType',
        'context': 'dict(str, FormserviceapiformsrendererexternalvalidationContext)',
        'project_id': 'str'
    }

    attribute_map = {
        'item': 'item',
        'filter': 'filter',
        'value_source': 'valueSource',
        'value_type': 'valueType',
        'context': 'context',
        'project_id': 'projectId'
    }

    def __init__(self, item=None, filter=None, value_source=None, value_type=None, context=None, project_id=None):  # noqa: E501
        """RendererExternalresourcesBody - a model defined in Swagger"""  # noqa: E501
        self._item = None
        self._filter = None
        self._value_source = None
        self._value_type = None
        self._context = None
        self._project_id = None
        self.discriminator = None
        if item is not None:
            self.item = item
        if filter is not None:
            self.filter = filter
        if value_source is not None:
            self.value_source = value_source
        if value_type is not None:
            self.value_type = value_type
        if context is not None:
            self.context = context
        if project_id is not None:
            self.project_id = project_id

    @property
    def item(self):
        """Gets the item of this RendererExternalresourcesBody.  # noqa: E501


        :return: The item of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: FormserviceapiformsrendererexternalresourcesItem
        """
        return self._item

    @item.setter
    def item(self, item):
        """Sets the item of this RendererExternalresourcesBody.


        :param item: The item of this RendererExternalresourcesBody.  # noqa: E501
        :type: FormserviceapiformsrendererexternalresourcesItem
        """

        self._item = item

    @property
    def filter(self):
        """Gets the filter of this RendererExternalresourcesBody.  # noqa: E501


        :return: The filter of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this RendererExternalresourcesBody.


        :param filter: The filter of this RendererExternalresourcesBody.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def value_source(self):
        """Gets the value_source of this RendererExternalresourcesBody.  # noqa: E501


        :return: The value_source of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: FormserviceapiformsrendererexternalvalidationSource
        """
        return self._value_source

    @value_source.setter
    def value_source(self, value_source):
        """Sets the value_source of this RendererExternalresourcesBody.


        :param value_source: The value_source of this RendererExternalresourcesBody.  # noqa: E501
        :type: FormserviceapiformsrendererexternalvalidationSource
        """

        self._value_source = value_source

    @property
    def value_type(self):
        """Gets the value_type of this RendererExternalresourcesBody.  # noqa: E501


        :return: The value_type of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: FormserviceapiformsrendererexternalvaluesFieldType
        """
        return self._value_type

    @value_type.setter
    def value_type(self, value_type):
        """Sets the value_type of this RendererExternalresourcesBody.


        :param value_type: The value_type of this RendererExternalresourcesBody.  # noqa: E501
        :type: FormserviceapiformsrendererexternalvaluesFieldType
        """

        self._value_type = value_type

    @property
    def context(self):
        """Gets the context of this RendererExternalresourcesBody.  # noqa: E501


        :return: The context of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: dict(str, FormserviceapiformsrendererexternalvalidationContext)
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this RendererExternalresourcesBody.


        :param context: The context of this RendererExternalresourcesBody.  # noqa: E501
        :type: dict(str, FormserviceapiformsrendererexternalvalidationContext)
        """

        self._context = context

    @property
    def project_id(self):
        """Gets the project_id of this RendererExternalresourcesBody.  # noqa: E501


        :return: The project_id of this RendererExternalresourcesBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this RendererExternalresourcesBody.


        :param project_id: The project_id of this RendererExternalresourcesBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RendererExternalresourcesBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RendererExternalresourcesBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
